def radixsort(a):
	"sort list of integers using base-10 radix sort, O(nlogn)"
	bins = [ [],[],[],[],[],[],[],[],[],[] ]
	m = max(a)
	# decimal digit currently partitioning on (1,10,100...)
	r = 1
	while m > r:
		# append each element of a to the end of the bin
		# corresponding to the partition digit
		for e in a:
			bins[(e/r)%10].append(e)
		r = r * 10
		print bins
		# move values from bins back to a single list
		a = []
		for i in range(10):
			a.extend(bins[i])
			bins[i] = []
		print a
	return a

if __name__=='__main__' :
	print radixsort([1,7,43,9,2,10,23,4,75])
